function map = hashinit (n)
% map = hashinit (n)
% creates an empty hashtable with n entries (default: n = 128)
% n : number of internal entries (optional)
% $Id: hashinit.m,v 1.3 2004/09/30 05:42:40 dmochiha Exp $
if nargin < 1
  n = 128; % default
else
  n = binpow(n); % 2^x power required
end
for i = n:-1:1
  map.val(i) = 0;
end
map.nnz = 0;
map.size = n;
