function n = hashval(map,key)
% n = hashval(map,key)
% returns a numerical value associated with 'key'.
% Tue Sep 28 20:14:21 JST 2004 dmochiha@slt.atr.jp
% $Id: hashval.m,v 1.4 2004/09/30 05:47:50 dmochiha Exp $
n = map.size;
h = hash(key,n);
h2 = hash2(key);

for i = 1:n
  if (map.val(h+1) == 0)
    n = 0;
    return;
  elseif strcmp(key,map.key{h+1})
    n = map.val(h+1);
    return;
  end
  h = mod(h + 2 * h2 + 1,n);
end
n = 0;

% hash function and utility
function h = hash(key,n)
h = 0;
for c = key
  h = mod(h * 33 + c,n);
end

function h2 = hash2(key)
k = 3; % first max 3 chars
l = min(k,size(key,2));
h2 = 7 - mod(sum(key(1:l)+0),8);

% End of file.
