function map = hashtable (cell,vals)
% map = hashtable (cell,valarray)
% creates a hashtable that binds each string to integer,
% cell{i} -> vals(i).
% depends on hashinit, hashadds.
% $Id: hashtable.m,v 1.3 2004/09/30 05:42:41 dmochiha Exp $
if (size(cell,2) ~= size(vals,2))
  error(['hashtable: number of strings and integers is ' ...
	 'not identical.']);
end
n = size(cell,2);
map = hashinit(n);
map = hashadds(map,cell,vals);
% end of file.
